1000 ! ------------------------------------------------!
1010 ! *         K E R M I T . 8 0 0                   !
1020 ! *         ===================                   !
1030 ! * BASIC-II Version for ABC-80x ABC-klubben      !
1040 ! * Torbj|rn Alm, ABC-116     83-11-17  V2.0      !
1050 ! * Per Lindberg QZ, ABC-816  83-11-24  V2.1      !
1060 ! * Torbj|rn Alm, ABC-116     84-04-10  V3.0      !
1065 ! * Lennart Wistedt Nokia-Luxor 86-08-13 V3.1     !
1070 ! * Version for ABC-800 follows UNIX-version in   !
1080 ! * KERMIT Protocol Manual closely exept for user !
1090 ! * interaction, which uses a more interactive    !
1100 ! * Dialogue and for connect.                     !
1110 ! * Debug printout on pr: device                  !
1120 ! * limited server handling                       !
1130 ! * Server program (limited)                      !
1140 ! * Basic dialect similar to Microsoft Basic      !
1150 ! * All variables are integers exept for strings  !
1160 ! ------------------------------------------------!
1170 INTEGER : EXTEND 
1180 DIM Zzz$=150
1190 Maxpack=78 : Soh=1 : Maxtry=5 : Myquote=ASCII('#') : Mypad=0 : Mypchar=0 : Myeol=13 : Mytime=10
1200 Maxtim=60 : Mintim=2 : True=-1 : False=0 : Fd=4 : Remfd=1 : Sp=32 : Del=127 : Brf=1 : Baud=9600 : Eol=13
1210 Sp$=SPACE$(25) : Version$='Version V3.1'
1220 POKE PEEK2(65500)+2,VAROOT(Zzz$),SWAP%(VAROOT(Zzz$))
1230 DIM Recpkt$=110,Packet$=110,Inbuff$=160,Q$=100,A$=70,Tabstop(160)
1240 FOR I=0 TO 160 : Tabstop(I)=0 : NEXT I 
1250 FOR I=0 TO 160 STEP 8 : Tabstop(I)=1 : NEXT I 
1260 Brf=FNBaud(Baud)
1265 OPEN 'v24:vsa24b30.'+CHR$(Brf+48,Brf+48,65) AS FILE Remfd
1270 WHILE True : ON FNHead GOTO 1280,1300,1340,1410,1430,1480,1530,1620,1600
1280   H=FNConnect : GOTO 1260 ! Dumb terminal until PF1
1290   ! -----  Receive files from remote ------------
1300   IF FNRecsw ; CUR(16,0) 'OK ' Sp$ ELSE ; CUR(16,0) 'Received failed ' Sp$
1310   IF Debug IF FNRecsw ; #17 'OK ' Sp$ ELSE ; #17 'Received failed ' Sp$
1320   ; '<Push any key to continue>'; : GET A$ : GOTO 1640
1330   ! -----  Send file to remote ------------------
1340   Nfiles=FNFiles(0) : IF Nfiles<=0 THEN 1640
1350   Ifile=1
1360   Filnam$=File$(Ifile)
1370   IF FNSendsw ; CUR(15,0) 'OK' Sp$; : GOTO 1390 ELSE ; CUR(15,0) ' Send failed' Sp$
1380   ; '<Push any key to continue>'; : GET A$
1390   GOTO 1640
1400   ! -----  Set Baud rate ------------------------
1410   INPUT 'Baud rate: ';Baud : Brf=FNBaud(Baud) : IF Brf THEN 1260 ELSE GOTO 1640
1420   ! -----  Set debug mode on/off each time ------
1430   IF Debug Debug=False : ; #17 'End of Debug Mode' : CLOSE 17 ELSE Debug=True : OPEN 'pr:' AS FILE 17 : ; #17 'Debug Mode'
1440   GOTO 1640
1450   ! --------------------------------------
1460   ! Start KERMIT Server tranmit in remote
1470   ! --------------------------------------
1480   ; CUR(14,0) 'Specify KERMIT Server transmit request     '
1490   ; CUR(15,0) SPACE$(160) CUR(15,0); : INPUT LINE A$ : A$=LEFT$(A$,LEN(A$)-2)
1500   N=0 : H=FNSpack(ASCII('R'),N,LEN(A$),A$) : State=ASCII('R') : Numtry=0 : File=1 : Nfiles=0
1510   H=FNRecworker
1520   GOTO 1640
1530   ! --------------------------------------
1540   ! Exit from KERMIT Server
1550   ! --------------------------------------
1560   H=FNSpack(ASCII('G'),N,1,'F')
1570   H=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Packet$))
1580   ; CUR(17,0) 'Exit from KERMIT Server ' Packet$
1590   H=FNDelay : GOTO 1640
1600   H=FNServer : ; 'Exit from KERMIT Server mode' : GOTO 1380
1610   ! ------ End of KERMIT Session ----------------
1620   ; CUR(15,20) 'E N D   o f  K E R M I T   s e s s i o n'
1630   STOP 
1640 WEND 
1650 STOP 
1660 ! ---------------------------------------------
1670 ! *   Kermit subroutines, standard from UNIX
1680 ! ---------------------------------------------
1690 ! * FNSpar$ = spar(data)
1700 ! send my parameters to other end
1710 ! ---------------------------------------------
1720 DEF FNSpar$=CHR$(Maxpack+32,Mytime+32,Mypad+32,Mypchar XOR 64,Myeol+32,Myquote) 
1730 ! ----------------------------------------------
1740 ! * FNRpar = rpar
1750 ! * Unpack data from other end
1760 ! ----------------------------------------------
1770 DEF FNRpar(S$)
1780   Spsiz=ASCII(S$)-32 : Timint=ASCII(MID$(S$,2,1))-32
1790   Pad=ASCII(MID$(S$,3,1))-32 : Padchar=ASCII(MID$(S$,4,1)) : Padchar=Padchar XOR 64
1800   Eol=ASCII(MID$(S$,5,1))-32 : Quote=ASCII(MID$(S$,6,1))
1810   RETURN 0
1820 FNEND 
1830 ! ----------------------------------------------
1840 ! * FNBufemp(buf,fd,len) 
1850 ! * unpack a packet to file
1860 ! * Buf    Packet buffer pointer, VARPTR(BUF$)
1870 ! * fd     file number
1880 ! * lgd    Packet length (redundant, only for compatibility)
1890 ! ______________________________________________
1900 DEF FNBufemp(Buf,Fd,Lgd) LOCAL I,T,Pp
1910   I=1 : Pp=Buf
1920   WHILE I<=Lgd : T=PEEK(Pp) : IF T=Myquote GOSUB 1950 ELSE ; #Fd CHR$(T); : Krad=Krad+1
1930   I=I+1 : Pp=Pp+1 : WEND 
1940   RETURN Lgd
1950   ! Unquote function
1960   I=I+1 : Pp=Pp+1 : T=PEEK(Pp)
1970   IF T=Myquote ; #Fd CHR$(T); : Krad=Krad+1 : RETURN ! ## = #
1980   T=T XOR 64 : IF T=Myeol Krad=0 ! End-of-line
1990   IF T=9 Krad=FNDetab(Krad) : RETURN ! HT
2000   ; #Fd CHR$(T); : RETURN 
2010 FNEND 
2020 ! -------------------------------------------------
2030 ! * BUF$= Fnbufill$
2040 ! * Fill buffer, return size
2050 ! --------------------------------------------------
2060 DEF FNBufill$ LOCAL B$=110,T
2070   B$=''
2080   WHILE True
2090     IF LEN(Inbuff$)=0 ON ERROR GOTO 2140 : INPUT LINE #2,Inbuff$ : Inbuff$=FNEntab$(Inbuff$)
2100     T=ASCII(Inbuff$) AND 127
2110     IF T<Sp OR T=Myquote OR T=Del IF LEN(B$)>Spsiz-9 RETURN B$ ELSE B$=B$+FNQ$(T) ELSE B$=B$+CHR$(T)
2120     Inbuff$=RIGHT$(Inbuff$,2) : IF LEN(B$)>=Spsiz-8 RETURN B$
2130   WEND 
2140   RESUME 2150
2150   RETURN B$
2160 FNEND 
2170 ! ---------------------------------------------------
2180 ! * FNSpack(type,num,length,data$)
2190 ! * Send packet to other end - call by name!
2200 ! ---------------------------------------------------
2210 DEF FNSpack(Type,Num,Length,Data$) LOCAL Chksum,Buffer$=160,I
2220   Buffer$=STRING$(Padchar,Pad)+CHR$(Soh,Length+35,Num+32,Type)+Data$
2230   Chksum=Length+Num+Type+67
2240   I=1 : WHILE I<=Length : Chksum=Chksum+ASCII(MID$(Data$,I,1)) : I=I+1 : WEND 
2250   Chksum=(Chksum+(Chksum AND 192)/64) AND 63
2260   Buffer$=Buffer$+CHR$(Chksum+32,Eol,10)
2270   ; #Remfd Buffer$; : ; CUR(15,0) 'Send packet ';N ' ' CHR$(Type) '  ' Numtry '   ';
2280   IF Debug ; #17 'Send packet ';N ' ' CHR$(Type) '  ' Numtry
2290   IF Debug ; #17 Buffer$
2300   RETURN LEN(Buffer$)
2310 FNEND 
2320 ! -----------------------------------------------------
2330 ! * FNRpack(&len,&num,&data$) - return type
2340 ! * Receive packet - store into data$ update varoot
2350 ! * Store len, num via pointers, return type
2360 ! -----------------------------------------------------
2370 DEF FNRpack(Length,Num,Datax) LOCAL T,Chksum,L,Done,Type
2380   ! RETURN FNQrpack(Length,Num,Datax)
2390   IF Timint>Maxtim OR Timint<Mintim THEN Timint=Mytime
2400   T=0 : WHILE T<>Soh : T=FNGetch : IF T<0 RETURN False
2410   WEND : Done=False
2420   WHILE Done=False
2430     T=FNGetch : IF T<0 RETURN False ELSE IF T=Soh GOTO 2510
2440     Chksum=T : L=T-35 : POKE Length,L,SWAP%(L) : T=FNGetch : IF T<0 RETURN False ELSE IF T=Soh GOTO 2510
2450     Chksum=Chksum+T : POKE Num,T-32,0 : T=FNGetch : IF T<0 RETURN False ELSE IF T=Soh GOTO 2510
2460     Chksum=Chksum+T : Type=T : Pp=PEEK2(Datax+2) : POKE Datax+4,0,0 ! VAROOT=maxsiz,pointer,len
2470     I=0 : WHILE I<L : T=FNGetch : IF T<0 RETURN False ELSE IF T=Soh GOTO 2510
2480     Chksum=Chksum+T : POKE Pp,T : Pp=Pp+1 : I=I+1 : WEND 
2490     T=FNGetch : IF T<0 RETURN False ELSE IF T=Soh GOTO 2510
2500     Done=True
2510   WEND 
2520   Chksum=(Chksum+(Chksum AND 192)/64) AND 63
2530   IF Chksum<>T-32 RETURN False
2540   ; CUR(15,40) ' Receive packet ' PEEK2(Num) ' ' N ' ' CHR$(Type) '   ' L '  ';
2550   IF Debug ; #17 ' Receive packet ' PEEK2(Num) ' ' N ' ' CHR$(Type) ' Len=' L
2560   POKE Datax+4,L,0 : IF NOT Debug RETURN Type
2570   POKE VAROOT(Q$)+2,PEEK(Datax+2),PEEK(Datax+3),PEEK(Datax+4),PEEK(Datax+5)
2580   ; #17 CHR$(L+35,PEEK(Num)+32)+Q$+CHR$(T+32)
2590   RETURN Type
2600 FNEND 
2610 ! ---------------------------------------------------
2620 ! * FNSendsw       Send supervisor
2630 ! ---------------------------------------------------
2640 DEF FNSendsw
2650   State=ASCII('S') : N=0 : Numtry=0 : WHILE True
2660     ON INSTR(1,'DFZSBCA',CHR$(State))+1 GOTO 2670,2680,2690,2700,2710,2720,2730,2740
2670     RETURN False ! unknown state - fail
2680     State=FNSdata : GOTO 2750 ! Data-Send state
2690     State=FNSfile : GOTO 2750 ! File-Send state
2700     State=FNSeof : GOTO 2750 ! End-of-file
2710     State=FNSinit : GOTO 2750 ! Send-Init
2720     State=FNSbreak : GOTO 2750 ! Break-Send
2730     RETURN True ! Complete
2740     RETURN False ! Abort
2750   WEND 
2760 FNEND 
2770 ! --------------------------------------------
2780 ! fnsinit  -  Send initiate
2790 ! Send my parameters, get other side's back
2800 ! --------------------------------------------
2810 DEF FNSinit LOCAL Num,Length,Type
2820   IF Debug ; CUR(14,0) 'Sinit                 '
2830   IF Numtry>Maxtry RETURN ASCII('A') ! Too many retries, give up
2840   Numtry=Numtry+1
2850   Packet$=FNSpar$
2860   IF Debug ; #17 'Packet #' N
2870   H=FNSpack(ASCII('S'),N,6,Packet$) ! Send an S-packet
2880   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Recpkt$)) ! What was the reply?
2890   IF Type=ASCII('N') RETURN State ! NAK
2900   IF Type=0 RETURN State ! Receive failure, stay in S
2910   IF Type=ASCII('E') H=FNErrpkt(Packet$)
2920   IF Type<>ASCII('Y') RETURN ASCII('A') ! Somethin bad - abort
2930   ! Type = 'Y'
2940   IF N<>Num RETURN State ! Wrong ACK stay S
2950   H=FNRpar(Recpkt$) ! Get other side's info
2960   IF Eol=0 Eol=13 ! Check and set defaults
2970   IF Quote=0 Quote=ASCII('#') ! Control prefix quote
2980   Numtry=0 : N=(N+1) AND 63 : IF Debug ; #17 'Opening ' Filnam$ ! Open file to be sent
2990   OPEN Filnam$ AS FILE 2 : Host=False : ; CUR(14,0) 'Sending  ' Filnam$ '      ';
3000   RETURN ASCII('F') ! Switch state to F
3010 FNEND 
3020 ! -----------------------------------------
3030 ! FNSfile     -       Send file header
3040 ! -----------------------------------------
3050 DEF FNSfile LOCAL Num,Length,H,Type,Fln$=16
3060   IF Debug ; #17 ' Sfile'
3070   Fln$=RIGHT$(Filnam$,INSTR(1,Filnam$,':')+1)
3080   IF Numtry>Maxtry RETURN ASCII('A') ! Too many retries, give up
3090   Numtry=Numtry+1
3100   Length=LEN(Fln$) : H=FNSpack(ASCII('F'),N,LEN(Fln$),Fln$) ! Send an F Packet
3110   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Recpkt$)) ! What was the reply?
3120   ON INSTR(1,'NYE'+CHR$(0),CHR$(Type))+1 GOTO 3190,3130,3140,3180,3170
3130   Num=((Num-1) AND 63) : IF N<>Num RETURN State ! NAK Stay in state
3140   IF N<>Num RETURN State ! Wrong ACK - stay in F state
3150   Numtry=0 : N=(N+1) AND 63 : Packet$=FNBufill$ : Size=LEN(Packet$)
3160   RETURN ASCII('D') ! Switch state to D
3170   RETURN State ! Receive failure - stay in F
3180   H=FNErrpkt(Recpkt$)
3190   RETURN ASCII('A') ! Something else, just abort
3200 FNEND 
3210 ! -----------------------------------------
3220 ! FNSData  -  Send Data File
3230 ! -----------------------------------------
3240 DEF FNSdata LOCAL Num,Length,H
3250   IF Numtry>Maxtry RETURN ASCII('A') ! Too many tries - give up
3260   Numtry=Numtry+1
3270   H=FNSpack(ASCII('D'),N,Size,Packet$) ! send a D packet
3280   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Recpkt$)) ! What was the reply?
3290   ON INSTR(1,'NYE'+CHR$(0),CHR$(Type))+1 GOTO 3370,3300,3310,3360,3350
3300   Num=((Num-1) AND 63) : IF N<>Num RETURN State ! unless NAK for next packet
3310   IF N<>Num RETURN State
3320   Oldtry=Numtry : Numtry=0 : N=(N+1) AND 63 : Pktnum=Pktnum+1 ! Bump packet count
3330   Packet$=FNBufill$ : Size=LEN(Packet$) : IF Size=0 RETURN ASCII('Z') ! EOF
3340   RETURN ASCII('D') ! Good data, stay in D
3350   RETURN State ! Receive failure
3360   H=FNErrpkt(Recpkt$)
3370   RETURN ASCII('A') ! Unknown reply, Abort
3380 FNEND 
3390 ! -----------------------------------------
3400 ! FNSeof  -  Send End-of-file
3410 ! -----------------------------------------
3420 DEF FNSeof LOCAL Num,Length,H
3430   IF Debug ; #17 'Seof'
3440   IF Numtry>Maxtry RETURN ASCII('A') ! Too many tries - give up
3450   Numtry=Numtry+1
3460   H=FNSpack(ASCII('Z'),N,0,'') ! send a Z packet
3470   IF Debug ; #17 'Seof1   '
3480   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Recpkt$)) ! Check reply
3490   ON INSTR(1,'NYE'+CHR$(0),CHR$(Type))+1 GOTO 3620,3500,3510,3610,3600
3500   Num=((Num-1) AND 63) : IF N<>Num RETURN State ! NAK, stay in state
3510   IF Debug ; #17 'Seof2'
3520   IF N<>Num RETURN State ! If wrong ACK, hold out
3530   Numtry=0 : N=(N+1) AND 63 ! reset try-counter and bump counter
3540   IF Debug ; #17 'Closing ' Filnam$
3550   CLOSE 2 : Fileopen=0 : IF Debug ; #17 'OK, Getting next file'
3560   Ifile=Ifile+1 : IF Ifile>Nfiles RETURN ASCII('B') ! EOT - all done
3570   Filnam$=File$(Ifile) : IF Debug ; #17 'New file is ' Filnam$
3580   OPEN Filnam$ AS FILE 2 : Fileopen=2
3590   RETURN ASCII('F') ! More files, switch to F
3600   RETURN State ! Receive failure, stay in state Z
3610   H=FNErrpkt(Recpkt$)
3620   RETURN ASCII('A') ! Something else, Abort
3630 FNEND 
3640 ! ------------------------------------------
3650 ! FNSbreak -  Send Break (EOT)
3660 ! ------------------------------------------
3670 DEF FNSbreak LOCAL Num,Length,H,Type
3680   IF Debug ; #17 'Sbreak'
3690   IF Numtry>Maxtry RETURN ASCII('A')
3700   Numtry=Numtry+1
3710   H=FNSpack(ASCII('B'),N,0,'') ! send a B packet
3720   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Recpkt$))
3730   ON INSTR(1,'NYE'+CHR$(0),CHR$(Type))+1 GOTO 3790,3740,3750,3780,3770
3740   Num=((Num-1) AND 63) : IF N<>Num RETURN State
3750   IF N<>Num RETURN State ! If wrong ACK, fail
3760   Numtry=0 : N=(N+1) AND 63 : RETURN ASCII('C') ! Switch State to Complete
3770   RETURN State
3780   H=FNErrpkt(Recpkt$)
3790   RETURN ASCII('A')
3800 FNEND 
3810 ! --------------------------------------------
3820 ! FNRecsw  -  State table switcher for receive files
3830 ! --------------------------------------------
3840 DEF FNRecsw
3850   Nfiles=FNFiles(1) : File=1 ! Assign local file names if necessary
3860   State=ASCII('R') : N=0 : Numtry=0 : RETURN FNRecworker
3870 FNEND 
3880 DEF FNRecworker
3890   WHILE True
3900     ON INSTR(1,'DFRCA',CHR$(State)) GOTO 3910,3920,3930,3940,3950
3910     State=FNRdata : GOTO 3970 ! Data Receive State
3920     State=FNRfile : GOTO 3970 ! File Receive State
3930     State=FNRinit : GOTO 3970 ! Send initiate State
3940     RETURN True ! Complete state
3950     IF Fileopen CLOSE Fileopen : Fileopen=0
3960     RETURN False ! Abort State
3970   WEND 
3980 FNEND 
3990 ! ----------------------------------------------
4000 ! FNRinit  -  Receive Initialization
4010 ! ----------------------------------------------
4020 DEF FNRinit LOCAL Num,Length,Type
4030   IF Numtry>Maxtry RETURN ASCII('A') ! Too many tries - abort
4040   Numtry=Numtry+1
4050   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Packet$))
4060   IF Type=False RETURN FNNak(State) ! Did not get a packet, NAK
4070   IF Type=ASCII('E') H=FNErrpkt(Packet$) : RETURN ASCII('A') ! Error response
4080   IF Type<>ASCII('S') RETURN ASCII('A') ! Some unexpected packet - abort
4090   H=FNRpar(Packet$) : Packet$=FNSpar$
4100   H=FNSpack(ASCII('Y'),N,6,Packet$) : Oldtry=Numtry
4110   Numtry=0 : N=(N+1) AND 63 : RETURN ASCII('F')
4120 FNEND 
4130 ! -----------------------------------------------
4140 ! FNRfile  -  Receive File Header
4150 ! -----------------------------------------------
4160 DEF FNRfile LOCAL Length,Num,Type,H
4170   IF Numtry>Maxtry RETURN ASCII('A') ! Too many tries, abort
4180   Numtry=Numtry+1
4190   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Packet$))
4200   ON INSTR(1,'SZFBE'+CHR$(0),CHR$(Type))+1 GOTO 4210,4220,4270,4300,4370,4400,4410
4210   RETURN ASCII('A') ! Default  -  Abort , unknown packet
4220   Oldtry=Oldtry+1 : IF Oldtry>Maxtry RETURN ASCII('A') ! Too many tries - abort
4230   IF Num<>((N-1) AND 63) RETURN ASCII('A') ! Not previous packet, abort
4240   Packet$=FNSpar$ : H=FNSpack(ASCII('Y'),Num,6,Packet$)
4250   Numtry=0 : RETURN State
4260   ! Case Z - End-of-file
4270   Oldtry=Oldtry+1 : IF Oldtry>Maxtry RETURN ASCII('A')
4280   IF Num<>((N-1) AND 63) RETURN ASCII('A') ! Not previous packet, abort
4290   H=FNSpack(ASCII('Y'),Num,0,'') : Numtry=0 : RETURN State
4300   ! Case F  -  File headre
4310   IF Num<>N RETURN ASCII('A') ! Wrong sequence-right block type
4320   IF FNGetfil(Packet$)=False ; CUR(15,0) 'Could not create' Packet$ : RETURN ASCII('A')
4330   IF Host=False ; CUR(14,0) ' Receiving ' Packet$ '       ';
4340   IF Debug ; #17 ' Receiving ' Packet$
4350   H=FNSpack(ASCII('Y'),N,0,'') ! Acknowledge file header
4360   Oldtry=Numtry : Numtry=0 : N=(N+1) AND 63 : RETURN ASCII('D') ! Switch to Data State
4370   ! Case B  -  End-of-Trashmission
4380   IF Num<>N RETURN ASCII('A') ! Need right packet number here
4390   H=FNSpack(ASCII('Y'),N,0,'') : RETURN ASCII('C') ! Goto Complete State
4400   H=FNErrpkt(Packet$) : RETURN ASCII('A')
4410   RETURN FNNak(State) ! Case FALSE - NAK
4420 FNEND 
4430 ! -----------------------------------------------
4440 ! FNRdata  -  Receive Data
4450 ! -----------------------------------------------
4460 DEF FNRdata LOCAL Num,Length,H,Type
4470   IF Numtry>Maxtry RETURN ASCII('A') ! Too many tries - abort
4480   Numtry=Numtry+1
4490   Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Packet$))
4500   IF Debug ; #17 ' Rx: ' Length Num Packet$
4510   ON INSTR(1,'DFZE'+CHR$(0),CHR$(Type))+1 GOTO 4530,4540,4590,4620,4520,4640
4520   H=FNErrpkt(Packet$)
4530   RETURN ASCII('A') ! Default - some other packet, abort
4540   IF Num=N GOTO 4560 ELSE Oldtry=Oldtry+1 : IF Oldtry>Maxtry RETURN ASCII('A')
4550   IF Num=((N-1) AND 63) H=FNSpack(ASCII('Y'),Num,6,Packet$) : Numtry=0 : RETURN State ELSE RETURN ASCII('A')
4560   H=FNBufemp(VARPTR(Packet$),Fd,LEN(Packet$)) : H=FNSpack(ASCII('Y'),N,0,'')
4570   Oldtry=Numtry : Numtry=0 : N=(N+1) AND 63 : RETURN ASCII('D')
4580   ! Case F  - File header
4590   Oldtry=Oldtry+1 : IF Oldtry>Maxtry RETURN ASCII('A')
4600   IF Num=((N-1) AND 63) H=FNSpack(ASCII('Y'),Num,0,'') : Numtry=0 : RETURN State ELSE RETURN ASCII('A')
4610   ! Case Z - End-of-file
4620   IF Num<>N RETURN ASCII('A')
4630   H=FNSpack(ASCII('Y'),N,0,'') : CLOSE Fd : Fileopen=0 : N=(N+1) AND 63 : RETURN ASCII('F')
4640   H=FNSpack(ASCII('N'),N,0,'') ! Nacka N{sta
4650   RETURN State
4660 FNEND 
4670 ! -------------------------------------------------
4680 ! FNConnect  -  Establish virtual terminal to remote host
4690 ! -------------------------------------------------
4700 DEF FNConnect
4710   IF Host ; CUR(15,0) 'Kermit: nothing to connect in Host mode ' CHR$(7,7,7) : RETURN 
4720   ; CUR(15,0) 'Kermit: connected - terminal mode with host - Push PF1 to exit'
4730   ON ERROR GOTO 4760
4740   OPEN 'V24:TSA30B24.'+CHR$(Brf+48,Brf+48,65) AS FILE 1 : GET #1,A$
4750   RETURN 0
4760   RESUME 4770
4770   ON ERROR GOTO : ; CHR$(12) 'Kermit: disconnected' : H=FNDelay : RETURN 0
4780 FNEND 
4790 ! -------------------------------------------------
4800 ! FNInchr$ - get char from remote line
4810 ! -------------------------------------------------
4820 DEF FNInchr$ LOCAL Dummy$=1
4830   GET #Remfd Dummy$ : RETURN CHR$(ASCII(Dummy$) AND 127) ! strip parity bit
4840 FNEND 
4850 ! ----------------------------------------------------
4860 ! FNBaud%(B%) - set up baud rate
4870 ! Input : Baud rate
4880 ! Output: Port setting
4890 ! ----------------------------------------------------
4900 DEF FNBaud(B) LOCAL I,Nb,K
4910   I=1 : RESTORE 4920 : READ Nb
4920   DATA 8,110,300,600,1200,2400,4800,9600,19200
4930   WHILE I<=Nb : READ K : IF B=K RETURN I
4940     I=I+1
4950   WEND 
4960   ; CUR(13,0) '**** Bad Baud rate =' B ' Not permitted  ****' CHR$(7,7,7) : RETURN 0
4970 FNEND 
4980 ! --------------------------------------------
4990 ! FNFiles - input file names - check files
5000 ! --------------------------------------------
5010 DEF FNFiles(Rsw) LOCAL Nfile,Aa$=162,I
5020   Nfile=0 : ; CUR(12,0) 'Specify File names                  '
5030   ; SPACE$(162) CUR(13,0); : INPUT LINE Aa$ : Aa$=LEFT$(Aa$,LEN(Aa$)-2) : IF LEN(Aa$)=0 RETURN 0
5040   Nfile=Nfile+1
5050   K=INSTR(1,Aa$,',')
5060   IF K File$(Nfile)=LEFT$(Aa$,K-1) : Aa$=RIGHT$(Aa$,K+1) : GOTO 5040
5070   File$(Nfile)=Aa$
5080   IF Rsw RETURN Nfile ! Receive mode, no file name check
5090   ON ERROR GOTO 5120
5100   I=1 : WHILE I<=Nfile : OPEN File$(I) AS FILE 2 : CLOSE 2 : I=I+1 : WEND 
5110   ON ERROR GOTO : RETURN Nfile
5120   RESUME 5130
5130   ; CUR(14,0) 'File ' File$(I) '  does not exist - abort !!!!!!' : GET A$ : ON ERROR GOTO : RETURN -1
5140 FNEND 
5150 ! --------------------------------------------
5160 ! FNGetch - Get line char one by one
5170 ! Basic BASIC - version, for level 1.0
5180 ! --------------------------------------------
5190 DEF FNGetch LOCAL Sec
5200   Sec=PEEK(65524)+Timint+1 : IF Sec>59 Sec=Sec-60
5210   IF PEEK2(PEEK2(65500)+6) RETURN ASCII(FNInchr$)
5220   IF Sec=PEEK(65524) RETURN -1 ELSE 5210
5230 FNEND 
5240 ! ---------------------------------------------
5250 ! FNHead  -  Print Meny - input command
5260 ! ---------------------------------------------
5270 DEF FNHead LOCAL F,F$=1
5280   ON ERROR GOTO 5440
5290   ; CHR$(12) '     K E R M I T  -  A B C - 8 0 0' SPACE$(20) Version$
5300   ; 
5310   ; 
5320   ; 'Kermit 800 functions'
5330   ; 'c   Connect to host computer'
5340   ; 'r   Receive files from host'
5350   ; 's   Send files to host'
5360   ; 'b   Specify Baud Rate (now ' Baud ' baud)'
5370   IF Debug ; 'd   Turn off debug mode (now on)' ELSE ; 'd   Turn on debug mode (now off)'
5380   ; 'g   Get files from Host Server'
5390   ; 'x   Exit from KERMIT remote Server'
5400   ; 'h   Enter Host Server Mode'
5410   ; 'e   Exit Kermit' : ; 
5420   ; CUR(13,0) 'Specify function: ' CHR$(8,7); : GET F$ : ; F$
5430   F=(INSTR(1,'CcRrSsBbDdGgXxEeHh',F$)+1)/2 : IF F ON ERROR GOTO : RETURN F ELSE 5420
5440   RESUME 
5450 FNEND 
5460 ! -------------------------------------------
5470 ! FNGetfil(A$)  -  Create new file
5480 ! -------------------------------------------
5490 DEF FNGetfil(Aa$) LOCAL A$=30
5500   A$=Aa$ : IF File<=Nfiles A$=File$(File) : File=File+1
5510   ON ERROR GOTO 5530 : PREPARE A$ AS FILE Fd : Fileopen=Fd : Krad=0 : RETURN True
5520   ! sorry pal - bad name
5530   RESUME 5540
5540   ON ERROR GOTO : ; CUR(14,0) 'File ' A$ ' Illegal file name'; : RETURN False
5550 FNEND 
5560 ! ---------------------------------
5570 ! FNQ$(T)  -  Quote a char
5580 ! ---------------------------------
5590 DEF FNQ$(T)
5600   IF T=Myquote RETURN CHR$(Myquote,Myquote) ! # is sent as ##
5610   RETURN CHR$(Myquote,T XOR 64) ! <32 or DEL toggle control bit
5620 FNEND 
5630 ! ----------------------------------------------------
5640 ! FNQrpack(&len,&num,&data$) - Emulate Rpack from keyboard
5650 ! ----------------------------------------------------
5660 DEF FNQrpack(Length,Num,Datax) LOCAL Typ,Pp,Ll,Nn,Dd$=90,Typ$=1
5670   ; CUR(22,0) SPACE$(79) CUR(22,0) 'Typ,num,text: '; : INPUT Typ$,Nn,Dd$
5680   Typ=ASCII(Typ$) : Ll=LEN(Dd$) : POKE Length,Ll,SWAP%(Ll) : POKE Num,Nn,SWAP%(Nn)
5690   Pp=PEEK2(Datax+2) : POKE Datax+4,Ll,SWAP%(Ll)
5700   I=1 : WHILE I<=Ll : POKE Pp,ASCII(MID$(Dd$,I,1))
5710   I=I+1 : Pp=Pp+1 : WEND 
5720   ; CUR(15,40) ' Receive packet ' N ' ' CHR$(Typ) Sp$;
5730   IF Debug ; #17 ' Receive packet ' PEEK2(Num) ' ' N ' ' CHR$(Typ)
5740   RETURN Typ
5750 FNEND 
5760 ! ----------------------------------------
5770 ! FNDelay  delay 2 seconds
5780 ! ----------------------------------------
5790 DEF FNDelay LOCAL X.
5800   X.=1. : WHILE X.<1200. : X.=X.+1. : WEND 
5810   RETURN 0
5820 FNEND 
5830 ! -------------------------------------------
5840 ! FNDetab - replace tabs by spaces
5850 ! -------------------------------------------
5860 DEF FNDetab(A) LOCAL B
5870   B=A+1 : ; #Fd ' ';
5880   WHILE Tabstop(B)=0 : ; #Fd ' '; : B=B+1 : WEND 
5890   RETURN B
5900 FNEND 
5910 ! -------------------------------------------
5920 ! FNEntab$(A$)  - Replace spaces by tabs
5930 ! -------------------------------------------
5940 DEF FNEntab$(A$) LOCAL B$=160,C$=160,Col,Newcol,Kk
5950   B$=A$ : C$='' : Col=0 : Kk=1
5960   WHILE Kk : Newcol=Col : WHILE ASCII(B$)=32
5970       Newcol=Newcol+1 : B$=RIGHT$(B$,2)
5980       IF Tabstop(Newcol) IF Newcol-Col>1 C$=C$+CHR$(9) : Col=Newcol ELSE C$=C$+' ' : Col=Newcol
5990     WEND 
6000     WHILE Col<Newcol : C$=C$+' ' : Col=Col+1 : WEND 
6010     C$=C$+LEFT$(B$,1) : B$=RIGHT$(B$,2) : Col=Col+1
6020     IF LEN(B$)<=2 C$=C$+B$ : Kk=0
6030   WEND 
6040   RETURN C$
6050 FNEND 
6060 ! -------------------------------------------
6070 ! FNErrpkt(P$) - Print error message
6080 ! -------------------------------------------
6090 DEF FNErrpkt(A$)
6100   ; CUR(17,0) 'Transmission aborted due to error: ' A$ : H=FNDelay : RETURN 0
6110 FNEND 
6120 ! --------------------------------------
6130 ! FNNak(s) send a NAK return state
6140 ! --------------------------------------
6150 DEF FNNak(S)
6160   H=FNSpack(ASCII('N'),N,0,'')
6170   RETURN S
6180 FNEND 
6190 ! --------------------------------------
6200 ! FNServer - Host server program
6210 ! --------------------------------------
6220 DEF FNServer LOCAL Type,Length,Num,K
6230   WHILE True
6240     Type=FNRpack(VARPTR(Length),VARPTR(Num),VAROOT(Packet$))
6250     ON INSTR(1,'GSRE'+CHR$(0),CHR$(Type))+1 GOTO 6450,6280,6400,6310,6440,6450
6260     ! *                                           ?    G    S    R    E   t.o.
6270     ! Generic Commands - So far Exit only (GF)
6280     IF LEFT$(Packet$,1)='F' THEN RETURN 0 ! Exit Server Mode Command (GF)
6290     Packet$='Unimplemented Server Command:'+Packet$
6300     H=FNSpack(ASCII('E'),N,LEN(Packet$),Packet$) : GOTO 6450
6310     Nfile=0 ! Receive command = send files request (R)
6320     Nfile=Nfile+1 : K=INSTR(1,Packet$,',')
6330     IF K File$(Nfile)=LEFT$(Packet$,K-1) : Packet$=RIGHT$(Packet$,K+1) : GOTO 6320
6340     File$(Nfile)=Packet$ : ON ERROR GOTO 6370
6350     I=1 : WHILE I<=Nfile : OPEN File$(I) AS FILE 2 : CLOSE 2 : I=I+1 : WEND 
6360     ON ERROR GOTO : H=FNSendsw : GOTO 6450
6370     RESUME 6380
6380     ON ERROR GOTO : Packet$='File not found:'+File$(I)
6390     H=FNSpack(ASCII('E'),N,LEN(Packet$),Packet$) : GOTO 6450
6400     State=ASCII('F') : Numtry=0 ! S-packet - receive files
6410     H=FNRpar(Packet$) : Packet$=FNSpar$ : H=FNSpack(ASCII('Y'),N,6,Packet$)
6420     Oldtry=Numtry : Numtry=0 : N=(N+1) AND 63
6430     H=FNRecworker : GOTO 6450
6440     H=FNErrpkt(Packet$) : RETURN 0
6450   WEND 
6460 FNEND 
